%% Initalization of Paraneters

clc
clear
%% ANN Structure
Thresh = .92;

NumofParticles = 30;
NPar = 243; % Number of Optimization Parameters
VarLow = 0; % Lower Limmit of problem
VarHigh = 1; % Upper Limmit of problem
ff = 'costFinal';
GlobalBestP = rand(1,NPar); % Global Best Position
GlobalBestP(GlobalBestP>Thresh) = 1;
GlobalBestP(GlobalBestP<Thresh) = 0;

GlobalBestC = feval(ff,GlobalBestP,0); % Global Best Cost
MaxIterations = 70;
DampCoef = 0.9999999;
C1 = 1.5;
C2 = 4 - C1;
%% Particles initialization
for i = 1:NumofParticles
    Particles{i}.Velocity = (rand(1,NPar)+2)*2;
    R = rand(1,NPar);
    Particles{i}.Position = R > 1./(1 + exp(-Particles{i}.Velocity));
%     sum(Particles{i}.Position==1)
    Particles{i}.Cost = feval(ff,Particles{i}.Position,0);
    Particles{i}.LocalBestPosition = Particles{i}.Position;
    Particles{i}.LocalBestCost = Particles{i}.Cost;

    if Particles{i}.Cost < GlobalBestC
        GlobalBestP = Particles{i}.Position;
        GlobalBestC = Particles{i}.Cost;
    end
end
%% Main loop
for t = 1:MaxIterations
    Damp = DampCoef^t;
    for i = 1:NumofParticles
        r1 = rand(1,NPar);
        r2 = rand(1,NPar);
        w = rand(1,NPar);
        Particles{i}.Velocity = Particles{i}.Velocity - ...
            r1*C1.*(Particles{i}.LocalBestPosition - Particles{i}.Position) - ...
            r2*C2.*(GlobalBestP - Particles{i}.Position);
        
        Particles{i}.Velocity = Particles{i}.Velocity * Damp;
        R = rand(1,NPar);
        Particles{i}.Position = R > 1./(1 + exp(-Particles{i}.Velocity));
        Particles{i}.Cost = feval(ff,Particles{i}.Position,0);
        
        for j = 1:NPar;  % To prevent the particles from exceeding the boundary condotions
            if Particles{i}.Position(j) > VarHigh
                Particles{i}.Position(j) = VarHigh;
            end

            if Particles{i}.Position(j) < VarLow
                Particles{i}.Position(j) = VarLow;
            end
        end
        
        if Particles{i}.Cost < Particles{i}.LocalBestCost;
            Particles{i}.LocalBestPosition = Particles{i}.Position;
            Particles{i}.LocalBestCost = Particles{i}.Cost;
            if Particles{i}.Cost < GlobalBestC
                GlobalBestP = Particles{i}.Position;
                GlobalBestC = Particles{i}.Cost;
            end
        end
        CostMatrix(i) = Particles{i}.Cost;
        ParticleMatrix(i,:) = Particles{i}.Position;
    end

    MeanCost = mean(CostMatrix);
    MinCost = GlobalBestC;
    MeanCostMatrix(t) = MeanCost;
    MinCostMatrix(t) = MinCost;
    plot(MinCostMatrix,'r','linewidth',3);
    xlim([1 MaxIterations])
    [t GlobalBestC]
%     hold on
%     plot(MeanCostMatrix,'.b','linewidth',2);
%     hold off
    pause(.01)
end

BestSolution = GlobalBestP
BestCost = GlobalBestC
%% Final Params
FinalCost = feval(ff,GlobalBestP,1);
disp('-----------------------------')
disp('Plost is:')
disp(FinalCost.Plost)

disp('-----------------------------')
disp('Capasitors are:')
disp(FinalCost.C)

disp('-----------------------------')
disp('Sum of Capacitors:')
disp(FinalCost.sumC)

disp('-----------------------------')
disp('Saturation:')
disp(FinalCost.Sat)

disp('-----------------------------')
disp('Total Cost is:')
disp(FinalCost.TotalCost)